! linksys.h
! routine di sistema di linklib.h
! Paolo Lucchesi, 2014-2015

System_File;

Property idglkobject;
Property hndglkevent;

[ TestGlkCapabilities res;
  @gestalt 4 2 res; if (res == 0) quit;
  if (glk_gestalt(gestalt_Graphics)) gs_graphic=true;
  if (glk_gestalt(gestalt_Hyperlinks)) gs_hyperlink=true;
  if (glk_gestalt(gestalt_Timer)) gs_timer=true;
];

[ GlkInit;
    !@gestalt 4 2 res; if (res == 0) quit;
    ! Inizializiamo le finestre
    @setiosys 2 0;
    GGRecoverObjects(true);
    InitGlkWindow(GG_MAINWIN_ROCK); 
    gg_mainwin = glk_window_open(0, 0, 0, 3, GG_MAINWIN_ROCK);
    if (gg_mainwin == 0) quit;
    InitGlkWindow(GG_STATUSWIN_ROCK);
    gg_statuswin = glk_window_open(gg_mainwin, (winmethod_Above+winmethod_Fixed), 1, wintype_Textgrid, GG_STATUSWIN_ROCK);
    if (gg_statuswin) { glk_window_clear(gg_statuswin); }
    DrawStatusFrame();
    glk_window_set_echo_stream(gg_mainwin);
    glk_set_window(gg_mainwin);
];

[ QuitGame;
    quit;
];

[ RestartGame;
    @restart;
    "^Riavvio Fallito.^";
];

[ RestoreGame res fref;
    fref = glk_fileref_create_by_prompt(fileusage_SavedGame+fileusage_BinaryMode, filemode_Read, 0);
    if (fref) {
        gg_savestr = glk_stream_open_file(fref, filemode_Read, GG_SAVESTR_ROCK);
        glk_fileref_destroy(fref);
        if (gg_savestr) {
            @restore gg_savestr res;
            glk_stream_close(gg_savestr, 0);
            gg_savestr = 0;
        }
    }
    "Caricamento Fallito.^";
];

[ SaveGame res fref;
    fref = glk_fileref_create_by_prompt(fileusage_SavedGame+fileusage_BinaryMode, filemode_Write, 0);
    if (fref) {
        gg_savestr = glk_stream_open_file(fref, filemode_Write, GG_SAVESTR_ROCK);
        glk_fileref_destroy(fref);
        if (gg_savestr) {
            @save gg_savestr res;
            if (res == -1) {
                ! Siamo dopo un restore
                GGRecoverObjects();
                glk_stream_close(gg_savestr, 0);
                gg_savestr = 0;
                printedloc = 0;
                "Caricamento Effettuato.^";
            }
            glk_stream_close(gg_savestr, 0);
            gg_savestr = 0;
            if (res == 0) "Salvataggio Effettuato.^";
        }
    }
];

[ SaveUndo res;
    @saveundo res;
    if (res == -1) {
        GGRecoverObjects();
        printedloc = 0;
        undoneturn = true;
        DescribeRoom(true);
        SaveUndo();
    }
    if (res == 1) undoflag=false;
];

[ UndoMove res;
    @restoreundo res;
    if (res) {
        undoflag=false;
        "Recupero situazione precedente fallito.^";
    }
];

[ GGRecoverObjects rnew id;
    ! If GGRecoverObjects() has been called, all these stored IDs are
    ! invalid, so we start by clearing them all out.
    ! (In fact, after a restoreundo, some of them may still be good.
    ! For simplicity, though, we assume the general case.)
    gg_mainwin = 0;
    gg_statuswin = 0;
#IfDef STATUS_WIN_UFRAME;
    gg_statuswinuf = 0;
#Endif;    
    gg_savestr = 0;
    ! Also tell the game to clear its object references.
    IdentifyGlkObjectExt(0); 

    id = glk_stream_iterate(0, gg_arguments);
    while (id) {
        switch (gg_arguments-->0) {
            GG_SAVESTR_ROCK: gg_savestr = id;
            default: IdentifyGlkObjectExt(1, 1, id, gg_arguments-->0);
        }
        id = glk_stream_iterate(id, gg_arguments);
    }
    id = glk_window_iterate(0, gg_arguments);
    while (id) {
        switch (gg_arguments-->0) {
            GG_MAINWIN_ROCK: gg_mainwin = id;
            GG_STATUSWIN_ROCK: gg_statuswin = id;
#IfDef STATUS_WIN_UFRAME;
            GG_STATUSWINUF_ROCK: gg_statuswinuf = id;
#Endif;    
            default: IdentifyGlkObjectExt(1, 0, id, gg_arguments-->0);
        }
        id = glk_window_iterate(id, gg_arguments);
    }
    if (rnew) {
      IdentifyGlkObjectExt(3);
#IfDef STATUS_WIN_UFRAME;
      if (gg_statuswinuf) glk_window_close(gg_statuswinuf); gg_statuswinuf = 0;
#Endif;       
      if (gg_statuswin) glk_window_close(gg_statuswin); gg_statuswin = 0;
      if (gg_mainwin) glk_window_close(gg_mainwin); gg_mainwin = 0;
      rtrue;
    }
    DrawStatusFrame();
    DrawStatus();

    ! Tell the game to tie up any loose ends.
    IdentifyGlkObjectExt(2);
];

[ IdentifyGlkObjectExt phase type ref rock x res;
    ! Chiama identifyglkobject per ogni estensione, e poi quella definita dall'autore
    res = 0;
    !print phase;
    objectloop(x in LibraryExtensions) {
        if (x provides idglkobject) res = x.idglkobject(phase, type, ref, rock);
    }
    IdentifyGlkObject(phase, type, ref, rock);
];

[ HandleGlkEventExt ev context x;
    ! In realta' fa anche altro...
    switch (ev-->0) {
      evtype_Arrange, evtype_Redraw:
        DrawStatusFrame(); DrawStatus();
      evtype_Timer:
        linktimer++;
    }
    objectloop(x in LibraryExtensions) {
        if (x provides hndglkevent) x.hndglkevent(ev,context);
    }
    HandleGlkEvent(ev,context);
];

    
[ KeyboardInput a_buffer bufferlen done;
    done = false;
    glk_request_line_event(gg_mainwin, a_buffer+WORDSIZE, bufferlen-WORDSIZE, 0);
    while (~~done) {
        glk_select(gg_event);
        switch (gg_event-->0) {
           evtype_Arrange, evtype_Redraw:
            DrawStatusFrame(); DrawStatus();
            !DrawStatusLine();
          evtype_LineInput:
            if (gg_event-->1 == gg_mainwin) {
                a_buffer-->0 = gg_event-->2;
                done = true;
            }
        }
        !ix = HandleGlkEvent(gg_event, 0, a_buffer);
        !if (ix == 2) done = true;
        !else if (ix == -1) done = false;
    }
];  
