! linktalk.h
! Estensione wtalk.h adattata a linklib.h
! Paolo Lucchesi, 2013-2015

System_File;

Property talk;
Property talker;
Property cant_talk;
!Property conversor;
Attribute static;
Attribute listfirst;

Default ALREADYTALKING "Lo stai gi@`a facendo.";
Default CANTTALKANSWER "Non hai niente da dire.";

!Object talktemp;

Class NPC
  with talk [x;
      if (~~(self provides conversor)) rfalse;
      x=self.conversor;
      if (metaclass(x) ~= object) rfalse;
      !if ((~~talkcheck(self)) && CANT_TALK_ANSWER ~= 0 or NULL) { PrintOrRunVar(CANT_TALK_ANSWER); rtrue; }   
      if ((~~talkcheck(self)) && x provides cant_talk) { x.cant_talk(); rtrue; }
      if (~~talkcheck(self)) { PrintRun(CANTTALKANSWER); "";}
      if (dialogline.talker==self) { PrintRun(ALREADYTALKING); ""; }
      dialogline.talker=self; 
      dialogline.operate();
      rtrue;
  ],
  istalking [; return(dialogline.talker==self); ],
  stoptalk [; 
      if (dialogline.talker ~= self) rfalse;
      dialogline.talker=0;
      dialogline.operate();
      rtrue;
  ],
  stilltalk [;
      return(talkcheck(self));
  ],
  removetalk [x;
      if (~~(self provides conversor)) rfalse;
      x=self.conversor;
      if (metaclass(x) ~= object) rfalse;
      while (child(x)) remove(child(x));
      if (dialogline.talker ~= self) rfalse;
      dialogline.talker=0;
      dialogline.operate();      
      rtrue;
  ],
  add [dlg frst;
      if (~~(self provides conversor)) rfalse;
      move dlg to self.conversor;
      if (frst) give dlg listfirst;
  ];
!  addlast [dlg x;
!      if (~~(self provides conversor)) rfalse;
!      x=self.conversor;
!      while (child(talktemp)) remove(child(talktemp)); ! non dovrebbe servire
!      while (child(x)) move child(x) to talktemp;
!      move dlg to x;
!      while (child(talktemp)) move child(talktemp) to x;
!  ];

Class Dialog
  with execute [muteflag x y;
    !!print "@<<", (name)self, "@>>^";
    if (~~parent(self)) rtrue;
    if (~~muteflag) if (self provides description) self.description();
    x = child(self);
    while (x) {
        y = sibling(x);
        if (x ofclass Dialog) move x to parent(self);
        x = y;
    }
    if (self hasnt static) remove self;
    dialogline.operate();
    rtrue; ! "";
  ],
  mute [;
    self.execute(true);
  ];

Constant GG_TALKWIN_ROCK 297;
Global gg_talkwin = 0;
#IfDef TALK_WIN_UFRAME;
  Constant GG_TALKWINUF_ROCK 296;
  Global gg_talkwinuf = 0;
#Endif;  

Object "linktalk" LibraryExtensions
  with 
    request [; if (gg_talkwin) glk_request_hyperlink_event(gg_talkwin); ],
    cancel [; if (gg_talkwin) glk_cancel_hyperlink_event(gg_talkwin); ],
    command [x;
        if (x ofclass Dialog) {
            if (x provides command) x.command();
            else print "@<<", (name)x, "@>>^";
            rtrue;
        }
        rfalse;
    ],
    process [x;
        if (x ofclass Dialog) {
            if (gg_talkwin) glk_window_clear(gg_talkwin);
            x.execute(); rtrue;
        }
        rfalse;
    ],
    hndglkevent [ev;
      if (ev-->0 == evtype_Arrange or evtype_Redraw) { TalkWindowClose(); dialogline.display(); }
    ],
    idglkobject [phase type ref rock;
        if (phase == 0) gg_talkwin = 0;
        if ((phase == 1) && (type == 0) && (rock == GG_TALKWIN_ROCK)) { gg_talkwin = ref; rtrue; }
#IfDef TALK_WIN_UFRAME;
        if (phase == 0) gg_talkwinuf = 0;
        if ((phase == 1) && (type == 0) && (rock == GG_TALKWINUF_ROCK)) { gg_talkwinuf = ref; rtrue; }
#Endif;  
        if (phase == 2) { TalkWindowClose(); dialogline.display(); }
        if (phase == 3) { TalkWindowClose(); }
        rfalse;
    ],
    each_turn [;
        dialogline.operate();
    ];

!Global talkinited = false;

#IfNDef TALK_MAINWINDOW;

[ TalkWindowOpen bg fg;
    if (gg_talkwin == 0) {
        gg_talkwin = glk_window_open(gg_mainwin, (winmethod_Below+winmethod_Fixed), 4, wintype_Textgrid, GG_TALKWIN_ROCK);
    }
    bg = 0; fg = $FFFFFF;
#IfDef TALK_WIN_UFRAME;
    if (gs_graphic) {
        if (glk_style_measure(gg_talkwin, style_Normal, stylehint_TextColor, gg_arguments)) 
            fg = gg_arguments --> 0;
        if (glk_style_measure(gg_talkwin, style_Normal, stylehint_BackColor, gg_arguments)) 
            bg = gg_arguments --> 0;
        if (gg_talkwinuf == 0) {
            gg_talkwinuf = glk_window_open(gg_mainwin, (winmethod_Below+winmethod_Fixed), 4, wintype_Graphics, GG_TALKWINUF_ROCK);
        }    
        glk_window_set_background_color(gg_talkwinuf, bg); 
        glk_window_clear(gg_talkwinuf);        
        glk_window_fill_rect(gg_talkwinuf,fg,1,1,2048,2);
    }
#Endif;
    rtrue;
];

[ TalkWindowReopen;
    !if (talkinited) dialogline.display();
    dialogline.display();
];

[ TalkWindowClose;
    if (gg_talkwin) glk_window_close(gg_talkwin, 0);
    gg_talkwin = 0;
#IfDef TALK_WIN_UFRAME;
    if (gg_talkwinuf) glk_window_close(gg_talkwinuf, 0);
    gg_talkwinuf = 0;
#Endif;
    rtrue;
];

#EndIf; ! ~TALK_MAINWINDOW

Stub TalkWindowOpen 0;
Stub TalkWindowReopen 0;
Stub TalkWindowClose 0;

KeyLink closetalklink "[CHIUDI]"
  with command "Interrompi la conversazione",
    description [; stopanytalk(); ""; ];

Object dialogline
  with ndialogs 0, dialog1 0, dialog2 0, dialog3 0,
    talker 0, lastturn false,
    operate [skipdisplay x y;
      self.ndialogs=0; self.dialog1=0; self.dialog2=0; self.dialog3=0;
      !print "--- ", (name)self.talker, " , ", TestScope(self.talker)), "^";
      if (self.talker) if (~~TestScope(self.talker)) self.talker=0;
      !if (self.talker) if (self.talker notin real_location) { self.talker=0; return; }
      if (self.talker) {
          y=self.talker;
          objectloop (x in y.conversor) {
              if (x ofclass Dialog && x hasnt locked && x has listfirst && self.ndialogs<3) {
                  if (x provides condition && ~~x.condition()) continue;
                  switch(++self.ndialogs) {
                      1: self.dialog1 = x;
                      2: self.dialog2 = x;
                      3: self.dialog3 = x;
                  }
              }
          }
          objectloop (x in y.conversor) {
              if (x ofclass Dialog && x hasnt locked && x hasnt listfirst && self.ndialogs<3) {
                  if (x provides condition && ~~x.condition()) continue;
                  switch(++self.ndialogs) {
                      1: self.dialog1 = x;
                      2: self.dialog2 = x;
                      3: self.dialog3 = x;
                  }
              }
          }
          if (self.ndialogs==0) self.talker=0;
      }
      if (~~skipdisplay) self.display();
    ],
    display [lines tp i;          
      lines = self.ndialogs; if (lines > 3) lines = 3;
      tp = i; ! Just to avoid warnings
    #Ifdef STATIC_TALKWINDOW;
      TalkWindowOpen();
    #Endif;
      if (self.ndialogs > 0) {
          TalkWindowOpen();
          if (gg_talkwin) {
              glk_set_window(gg_talkwin);
              glk_window_clear(gg_talkwin);
              glk_window_move_cursor(gg_talkwin,0,0);
          } else {
              print "^";
          }
          print "(Parlando con ", (artname)self.talker, ")^";
          ! Quanto e' larga?
          if (gg_talkwin) {
            glk_window_get_size(gg_mainwin, gg_arguments, gg_arguments+4);
            i = gg_arguments-->0;
            ! Se e' meno di 56 stampo i link compatti
            if (i < 56) {
              glk_window_move_cursor(gg_talkwin,i-4,0); 
              link(closetalklink); print "[X]"; link(0);
            } else {  
              glk_window_move_cursor(gg_talkwin,i-9,0);
              link(closetalklink); print "[CHIUDI]"; link(0);
            }
          }
          for (i=1: i<=lines: i++) {
              switch(i) { 1: tp=self.dialog1;
                          2: tp=self.dialog2;
                          3: tp=self.dialog3;
                        }
              if (gg_talkwin) glk_window_move_cursor(gg_talkwin,0,i); 
              link(tp); print (name)tp, "^"; link(0);
          }
          glk_set_window(gg_mainwin);  ! set_window
      }
      else {
        #Ifdef STATIC_TALKWINDOW;
          if (gg_talkwin) {
              glk_set_window(gg_talkwin);
              glk_window_clear(gg_talkwin);
              glk_set_window(gg_mainwin);! set_window
          }
        #Ifnot;
          TalkWindowClose();
        #Endif;
      }
    ];

[ talking;
    if (dialogline.ndialogs > 0) return dialogline.talker;
    rfalse;
];


![ xinternalcanttalk;
!  #Ifdef NPerson;
!    if (NPerson==FIRST_PERSON) "Non ho niente da dire.";
!  #Endif;
!    "Non hai niente da dire.";
!];

[ talkcheck obj x;
  if (~~(obj provides conversor)) rfalse;
  for (x = (child(obj.conversor)) : x : x = sibling(x) ) {
    if (x ofclass Dialog && x hasnt locked) {
      if (x provides condition && ~~x.condition()) ;
      else rtrue;
    }
  }
  rfalse;
];  

[ talkwith obj force x;
    if (dialogline.talker && ~~force) rtrue;
    if (obj == 0 or NULL) {
        dialogline.talker = 0;
        rtrue;
    }
    if (obj ofclass NPC && obj provides conversor) {
        dialogline.talker=obj;
        x=obj.conversor;
        dialogline.operate();
        rtrue;
    }
    rfalse;
];

[ stopanytalk;
    dialogline.talker = 0;
    dialogline.operate();
    rtrue;
];

[ removeanytalk obj x;
    obj = dialogline.talker;
    if (obj == 0) rfalse;
    if (~~(obj provides conversor)) rfalse;
    x=obj.conversor;
    while (child(x)) remove(child(x));
    dialogline.talker=0;
    dialogline.operate();      
    rtrue;
];

!--- per evitare warning
!Object xwtalkxdummyx
!   with xproc [; talkwith(); stoptalk(); TalkWindowOpen(); TalkWindowReopen();
!                 TalkWindowClose(); talking(); ],
!		conversor 0;
   
