! linktest.h
! routine  linklib.h
! Paolo Lucchesi, 2014-2015

System_File;

Global linktestactive=false;

Constant GG_TESTWIN_ROCK 293;
Global gg_testwin;
#IfDef STATUS_WIN_UFRAME;
  Constant GG_TESTWINUF_ROCK 294;
  Global gg_testwinuf = 0;
#Endif;

Constant GG_SCRIPTFILE_ROCK 401;
Global gg_scriptfile;
Constant GG_SCRIPTSTREAM_ROCK 302;
Global gg_scriptstream;

Constant REMARKLEN 255;
Array remarkb buffer REMARKLEN;

Object betatestmenu;
KeyLink -> betatestscripton
  with command "Script On",
    description [; TestScriptOn(); ""; ];
KeyLink -> betatestscriptoff
  with command "Script Off",
    description [; TestScriptOff(); ""; ];
KeyLink -> betatestcomment
  with command "Remark",
    description [; TestRemark(); ""; ];
    
[ DisplayTestMenu x;
  if (gg_testwin == 0) rfalse;
  glk_set_window(gg_testwin);
  glk_window_clear(gg_testwin);
  objectloop(x in betatestmenu) {
    link(x); print "[", (string)x.command, "]"; link(0); print " ";
  }
  glk_set_window(gg_mainwin);
];

[ TestRemark;
    print "!>> "; 
    GetString(remarkb,REMARKLEN);
];

![ TestRemark;
!    print "!>> "; 
!    glk_request_line_event(gg_mainwin, remarkb+WORDSIZE, REMARKLEN-WORDSIZE, 0);
!    while(true) {
!      glk_select(gg_event);
!      if (gg_event-->0 == evtype_LineInput) rtrue;
!    }
!];

[ TestScriptOn;
    if (gg_scriptstream) "Trascrizione gi@`a attiva.";
    if (gg_scriptfile == 0) gg_scriptfile = glk_fileref_create_by_prompt(fileusage_Transcript+fileusage_TextMode, filemode_WriteAppend, GG_SCRIPTFILE_ROCK);
    if (gg_scriptfile) {
        gg_scriptstream = glk_stream_open_file(gg_scriptfile, filemode_WriteAppend, GG_SCRIPTSTREAM_ROCK);
        glk_fileref_destroy(gg_scriptfile); gg_scriptfile = 0;
        if (gg_scriptstream) {
            glk_window_set_echo_stream(gg_mainwin, gg_scriptstream);
        #IfDef TITLE;
            print "^*** ", (string)TITLE, " ***";
        #EndIf;
        #IfDef RELEASEID;
            print "^", (string)RELEASEID;
        #EndIf;
            "^Trascrizione attivata.";
        }
    }
    "Errore nella creazione della trascrizione.";
];

[ TestScriptOff;
    if (gg_scriptstream == 0) "Trascrizione non attiva.";
    print "Fine della trascrizione.^";
    glk_stream_close(gg_scriptstream);
    gg_scriptstream = 0;
];

[ TestWindowUpdate;
    if (linktestactive) {
        TestWindowOpen(); DisplayTestMenu();
    } else {
        TestWindowClose();
    }
];

[ TestWindowOpen bg fg;
    if (gg_testwin == 0) {
        gg_testwin = glk_window_open(gg_mainwin, (winmethod_Below+winmethod_Fixed), 1, wintype_Textgrid, GG_TESTWIN_ROCK);
    }
    bg = 0; fg = $FFFFFF;
#IfDef STATUS_WIN_UFRAME;
    if (gs_graphic) {
        if (glk_style_measure(gg_testwin, style_Normal, stylehint_TextColor, gg_arguments)) 
            fg = gg_arguments --> 0;
        if (glk_style_measure(gg_testwin, style_Normal, stylehint_BackColor, gg_arguments)) 
            bg = gg_arguments --> 0;
        if (gg_testwinuf == 0) {
            gg_testwinuf = glk_window_open(gg_mainwin, (winmethod_Below+winmethod_Fixed), 4, wintype_Graphics, GG_TESTWINUF_ROCK);
        }    
        glk_window_set_background_color(gg_testwinuf, bg); 
        glk_window_clear(gg_testwinuf);        
        glk_window_fill_rect(gg_testwinuf,fg,1,1,2048,2);
    }
#Endif;
    rtrue;
];

[ TestWindowClose;
#IfDef STATUS_WIN_UFRAME;
    if (gg_testwinuf) glk_window_close(gg_testwinuf, 0);
    gg_testwinuf = 0;
#Endif;
    if (gg_testwin) glk_window_close(gg_testwin, 0);
    gg_testwin = 0;
    rtrue;
];

Object "linktest" LibraryExtensions
  with request [; if (gg_testwin) glk_request_hyperlink_event(gg_testwin); ],
    initial [; TestWindowUpdate(); ],
    hndglkevent [ev;
      if (ev-->0 == evtype_Arrange or evtype_Redraw) { TestWindowClose(); TestWindowUpdate(); }
    ],
    idglkobject [phase type ref rock;
        if (phase == 0) {
            gg_testwin = 0;
            gg_scriptfile = 0;
            gg_scriptstream = 0;
        }
        if ((phase == 1) && (type == 0) && (rock == GG_TESTWIN_ROCK)) { gg_testwin = ref; rtrue; }
        if ((phase == 1) && (type == 1) && (rock == GG_SCRIPTSTREAM_ROCK)) { gg_scriptstream = ref; rtrue; }
        if ((phase == 1) && (type == 2) && (rock == GG_SCRIPTFILE_ROCK)) { gg_scriptfile = ref; rtrue; }
#IfDef STATUS_WIN_UFRAME;
        if (phase == 0) gg_testwinuf = 0;
        if ((phase == 1) && (type == 0) && (rock == GG_TESTWINUF_ROCK)) { gg_testwinuf = ref; rtrue; }
#Endif;          
        if (phase == 2) { TestWindowUpdate(); }
        if (phase == 3) TestWindowClose();
        rfalse;
    ];
